#pragma once

#include "CoreMinimal.h"
#include "ChallengeTrackerContainerViewInterface.h"
#include "CoreBaseHudWidget.h"
#include "Templates/SubclassOf.h"
#include "CoreChallengeTrackerContainerWidget.generated.h"

class UUserWidget;
class UOverlay;
class UCoreChallengeTrackerWidget;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIVIEWSCORE_API UCoreChallengeTrackerContainerWidget : public UCoreBaseHudWidget, public IChallengeTrackerContainerViewInterface
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UUserWidget> ChallengeTrackerWidgetClass;

protected:
	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UOverlay* ChallengeTrackerWidgetsContainer;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, NoClear, meta=(AllowPrivateAccess=true))
	float ReadingTimeDelaySec;

	UPROPERTY(BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UCoreChallengeTrackerWidget* _challengeTrackerWidget;

private:
	UFUNCTION(BlueprintCallable)
	void OnWidgetProgressingDone(UCoreChallengeTrackerWidget* trackerWidget);

	UFUNCTION(BlueprintCallable)
	void OnWidgetOpeningDone(UCoreChallengeTrackerWidget* trackerWidget);

	UFUNCTION(BlueprintCallable)
	void OnWidgetClosingDone(UCoreChallengeTrackerWidget* trackerWidget);

	UFUNCTION(BlueprintCallable)
	void OnReadingTimeDelayDone();

public:
	UCoreChallengeTrackerContainerWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreChallengeTrackerContainerWidget) { return 0; }
